#include <windows.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <tchar.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <io.h>

typedef struct STEXTPOStag{
	int	 x;
	int	 y;
	int	 width;
	int	 height;
	char text[500];
}STEXTPOS;

#pragma comment( lib, "../lib/i2pocrsdk.lib" )

__declspec(dllexport) int    WINAPI Image2PDFOCR_SinglePage_GetTextInfo(char *lpszPDFFile, LPBYTE *lpChars, char *lpszOptions);
__declspec(dllexport) void   WINAPI Image2PDFOCR_SinglePage_FreeTextInfo(LPBYTE lpChars);
__declspec(dllexport) int    WINAPI Image2PDFOCR_SinglePage_CreatePDF(char *lpszInPDFFile, LPBYTE lpChars, int nCharCount, char *lpszOutPDFFile, char *lpszOptions);
__declspec(dllexport) int    WINAPI Image2PDFOCR_PDFCmd(char *lpszOptions);
__declspec(dllexport) int    WINAPI Image2PDFOCR_CreateSearchablePDF(const char *lpTIFOrPDFFile, const char *lpOutputFile, const char *lpOptions);

__declspec(dllexport) HANDLE WINAPI Image2PDFOCR_GetTextHandle(char *lpszTIFOrPDFFile, char *lpszOptions);
__declspec(dllexport) int    WINAPI Image2PDFOCR_GetOCRedPageCount(HANDLE hImage2PDFData);
__declspec(dllexport) int    WINAPI Image2PDFOCR_GetTextInfo(HANDLE hImage2PDFData, int nPage, LPBYTE *lpOutTextInfo);
__declspec(dllexport) int    WINAPI Image2PDFOCR_SetTextInfo(HANDLE hImage2PDFData, int nPage, LPBYTE lpInTextInfo, int nCharNum);
__declspec(dllexport) void   WINAPI Image2PDFOCR_FreeTextHandle(HANDLE hImage2PDFData);
__declspec(dllexport) int    WINAPI Image2PDFOCR_CreatePDF(HANDLE hImage2PDFData, char *lpszOutPDFFile, char *lpszOptions);
__declspec(dllexport) int    WINAPI Image2PDFOCR_CreatePDFInMemory(HANDLE hImage2PDFData, char *lpszOptions, LPBYTE *lpDataBuf, int *nDataBufLen);
__declspec(dllexport) int    WINAPI Image2PDFOCR_GetPageCount(char *lpszPDFFile);
__declspec(dllexport) int	 WINAPI Image2PDFOCR_GetWordCountOnPage(HANDLE hImage2PDFData, int nPage);
__declspec(dllexport) int	 WINAPI Image2PDFOCR_GetWordInfoByIndex(HANDLE hImage2PDFData, int nPage, int nWordIndex, int *X, int *Y, int *Width, int *Height, char *lpText);
__declspec(dllexport) int	 WINAPI Image2PDFOCR_SetWordInfoByIndex(HANDLE hImage2PDFData, int nPage, int nWordIndex, int X, int Y, int Width, int Height, char *lpText);

void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}

int main()
{
	char *lpLicenseKey = "-$ XXXXXXXXXXXXXXXXXXXXXX";
	int nRet = 0;
	//Example #1, Convert TIFF file to searchable PDF file directly
	if(1)
	{
		char szInFile[MAX_PATH] = {0};
		char szOutFile[MAX_PATH] = {0};
		GetModulePath(szInFile,"DOCSPROD__1000_v1_17_Oct_95.TIF");
		GetModulePath(szOutFile,"_DOCSPROD__1000_v1_17_Oct_95.tif.ocred.pdf");
		char szOptions[4096] = {0};
		sprintf(szOptions, "-chkbwcolor %s", lpLicenseKey);
		nRet = Image2PDFOCR_CreateSearchablePDF(szInFile, szOutFile, szOptions);
		printf("Example #1 return '%d'\n", nRet);
	}
	if(1)
	{
		char szInFile[MAX_PATH] = {0};
		char szOutFile[MAX_PATH] = {0};
		GetModulePath(szInFile,"DOCSPROD__1001_v1_17_Oct_95.TIF");
		GetModulePath(szOutFile,"_DOCSPROD__1001_v1_17_Oct_95.tif.ocred.pdf");
		char szOptions[4096] = {0};
		sprintf(szOptions, "-chkbwcolor %s", lpLicenseKey);
		nRet = Image2PDFOCR_CreateSearchablePDF(szInFile, szOutFile, szOptions);
		printf("Example #1 return '%d'\n", nRet);
	}

	if(1)
	{
		char szInFile[MAX_PATH] = {0};
		char szOutFile[MAX_PATH] = {0};
		GetModulePath(szInFile, "DOCSPROD__1000_v1_17_Oct_95.TIF");
		GetModulePath(szOutFile, "___DOCSPROD__1000_v1_17_Oct_95.tif.ocred.pdf");

		char szOCRPDFCmd[1024] = {0};
		sprintf(szOCRPDFCmd, "-ocr 1 -tsocr -tsocrlang eng -chkbwcolor %s \"%s\" \"%s\"", lpLicenseKey, szInFile, szOutFile);
		nRet = Image2PDFOCR_PDFCmd(szOCRPDFCmd);
	}
	if(1)
	{
		char szInFile[MAX_PATH] = {0};
		char szOutFile[MAX_PATH] = {0};
		GetModulePath(szInFile, "DOCSPROD__1001_v1_17_Oct_95.TIF");
		GetModulePath(szOutFile, "___DOCSPROD__1001_v1_17_Oct_95.tif.ocred.pdf");
		
		char szOCRPDFCmd[1024] = {0};
		sprintf(szOCRPDFCmd, "-ocr 1 -tsocr -tsocrlang eng -chkbwcolor %s \"%s\" \"%s\"", lpLicenseKey, szInFile, szOutFile);
		nRet = Image2PDFOCR_PDFCmd(szOCRPDFCmd);
	}

	return nRet;
}